typedef struct AdaptiveBitModel {
	int order;
	UINT* model;
	UINT context;
	UINT mask;
	UINT adaptrate;
	UINT adaptinv;
	UINT adaptmax;
} ABitModel, *PABitModel;
PABitModel InitABM(int modelOrder) {
	LONG init;
	PABitModel bm = (PABitModel) MemAlloc(sizeof(ABitModel));
	bm->order = modelOrder;
	bm->mask = (1 << modelOrder) - 1;
	bm->context = 0;
	bm->model = (UINT*) MemAlloc(sizeof(UINT) * (bm->mask + 1));
	if(IsInvalidPtr(bm->model)) {
		MemFree(bm);
		return NULL;
	};
	for(init = 0; init <= bm->mask; init++) {
		bm->model[init] = 0x80000000;
	};
	bm->adaptrate = 10 + ((bm->order << 1) / 3);
	bm->adaptinv = 32 - bm->adaptrate;
	bm->adaptmax = 1 << bm->adaptrate;
	return bm;
};
__forceinline UINT ABMP1(PABitModel bm) {
	return bm->model[bm->context];
};
__forceinline void ABMUpdate(PABitModel bm, BOOL bit) {
	if(bit == FALSE) {
		if(bm->model[bm->context] < 0xFFFFFFF0) { bm->model[bm->context] += bm->adaptmax - (bm->model[bm->context] >> bm->adaptinv); };
		bm->context = (bm->context << 1) & bm->mask;
	} else {
		if(bm->model[bm->context] > 0x0000000F) { bm->model[bm->context] -= 1 + (bm->model[bm->context] >> bm->adaptinv); };
		bm->context = ((bm->context << 1) | 1) & bm->mask;
	};
};
void DestroyABM(PABitModel bm) {
	MemFree(bm->model);
	MemFree(bm);
};