typedef struct RangeCoder32 {
	PBUFFERED_FILE baseFile;
	BOOL first;
	LONG loVal;
	LONG hiVal;
	LONG midVal;
	LONG code;
	BOOL bitVal;
	UINT tmpVal;
	LONG writeCount;
	LONG readCount;
	BOOL atEnd;
} RangeCoder32, *PRangeCoder32;
PRangeCoder32 InitRC32(PBUFFERED_FILE file) {
	PRangeCoder32 rc = (PRangeCoder32) MemAlloc(sizeof(RangeCoder32));
	rc->baseFile = file;
	rc->first = TRUE;
	rc->loVal = 0;
	rc->hiVal = 4294967295;
	rc->midVal = 0;
	rc->code = 0;
	rc->bitVal = FALSE;
	rc->tmpVal = 0;
	rc->writeCount = 0;
	rc->readCount = 0;
	rc->atEnd = FALSE;
	return rc;
};
void RC32GetRange(PRangeCoder32 rc, UINT prob) {
	rc->midVal = rc->hiVal - ((((LONG) (rc->hiVal - rc->loVal)) * (LONG) prob) >> 32);
	if(rc->midVal >= rc->hiVal) { rc->midVal -= 2; };
	if(rc->midVal <= rc->loVal) { rc->midVal += 2; };
};
void RC32EncodeBit(PRangeCoder32 rc, BOOL bit, UINT prob) {
	RC32GetRange(rc, prob);
	if(bit == TRUE) {
		rc->hiVal = rc->midVal;
	} else {
		rc->loVal = rc->midVal + 1;
	};
	while(((rc->hiVal ^ rc->loVal) & 0xFF000000) == 0) {
		WriteBufferedByte(rc->baseFile, (BYTE) (rc->loVal >> 24));
		rc->hiVal = (rc->hiVal << 8) | 0xFF;
		rc->loVal <<= 8;
		rc->writeCount++;
	};
};
BOOL RC32DecodeBit(PRangeCoder32 rc, UINT prob) {
	RC32GetRange(rc, prob);
	if(rc->first == TRUE) {
		rc->code = (rc->code << 8) | ReadBufferedByte(rc->baseFile);
		rc->code = (rc->code << 8) | ReadBufferedByte(rc->baseFile);
		rc->code = (rc->code << 8) | ReadBufferedByte(rc->baseFile);
		rc->code = (rc->code << 8) | ReadBufferedByte(rc->baseFile);
		rc->first = FALSE;
	};
	if(rc->code <= rc->midVal) {
		rc->bitVal = TRUE;
		rc->hiVal = rc->midVal;
	} else {
		rc->bitVal = FALSE;
		rc->loVal = rc->midVal + 1;
	};
	while(((rc->hiVal ^ rc->loVal) & 0xFF000000) == 0) {
		rc->tmpVal = ReadBufferedByte(rc->baseFile);
		if(rc->tmpVal != -1) {
			rc->code = (rc->code << 8) | rc->tmpVal;
			rc->hiVal = (rc->hiVal << 8) | 0xFF;
			rc->loVal <<= 8;
			rc->readCount++;
		} else {
			rc->atEnd = TRUE;
			return rc->bitVal;
		};
	};
	return rc->bitVal;
};
void RC32Flush(PRangeCoder32 rc) {
	int fc;
	for(fc = 0; fc < 32; fc++) { RC32EncodeBit(rc, FALSE, 0x80000000); };
	FlushBufferedFile(rc->baseFile, FALSE);
};
void DestroyRC32(PRangeCoder32 rc) {
	MemFree(rc);
};