typedef struct ByteBitModel {
	int order;
	PValPair model;
	UINT context;
	UINT tempctx;
	UINT realctx;
	UINT mask;
	UINT pos;
	UINT val;
	ValPair tmp;
} BBitModel, *PBBitModel;
PBBitModel InitBBM(int modelOrder) {
	LONG init;
	PBBitModel bm = (PBBitModel) MemAlloc(sizeof(BBitModel));
	bm->order = modelOrder;
	bm->mask = (1 << modelOrder) - 1;
	bm->context = 0;
	bm->realctx = 0;
	bm->pos = 0;
	bm->val = 0;
	bm->model = (PValPair) MemAlloc(sizeof(ValPair) * (bm->mask + 1));
	if(IsInvalidPtr(bm->model)) { 
		MemFree(bm);
		return NULL;
	};
	for(init = 0; init <= bm->mask; init++) {
		bm->model[init].v0 = 1;
		bm->model[init].vt = 2;
	};
	return bm;
};
__forceinline UINT BBMP1(PBBitModel bm) {
	bm->tmp = bm->model[bm->realctx];
	return ((LONG) bm->tmp.v0 * (LONG) 0xFFFFFFFF) / ((LONG) bm->tmp.vt);
};
__forceinline void BBMUpdate(PBBitModel bm, BOOL bit) {
	bm->model[bm->realctx].vt++;
	if(bit == FALSE) {
		bm->model[bm->realctx].v0++;
		bm->context = (bm->context << 1);
	} else {
		bm->context = (bm->context << 1) | 1;
	};
	if(bm->pos == 7) {
		bm->tempctx = (((bm->context >> 24) & 0xFF) + 512) * 773;
		bm->tempctx = (bm->tempctx + ((bm->context >> 16) & 0xFF) + 512) * 773;
		bm->tempctx = (bm->tempctx + ((bm->context >> 8) & 0xFF) + 512) * 773;
		bm->tempctx = (bm->tempctx + (bm->context & 0xFF) + 512) * 773;
		bm->realctx = bm->tempctx ^ 1;
		bm->pos = 0;
		bm->val = bit & 1;
	} else {
		bm->pos++;
		if(bm->pos < 4) {
			bm->realctx = bm->tempctx ^ ((1 << bm->pos) | bm->val);
		} else {
			bm->realctx = bm->tempctx ^ (0x100 | (1 << (bm->pos - 4)) | ((bm->val & 0xF) << 4) | (bm->val >> 4));
		};
		bm->val |= (bit & 1) << bm->pos;
	};
	bm->realctx &= bm->mask;
};
void DestroyBBM(PBBitModel bm) {
	MemFree(bm->model);
	MemFree(bm);
};