LONG const hmaxmask = 0x1FFFFFFFFFFFFFFF;
typedef struct HashBitModel {
	int order;
	PValPair model;
	LONG context;
	LONG mask;
	int pos;
	ValPair tmp;
} HBitModel, *PHBitModel;
PHBitModel InitHBM(int modelOrder) {
	LONG init;
	PHBitModel bm = (PHBitModel) MemAlloc(sizeof(HBitModel));
	bm->order = modelOrder;
	bm->mask = (1 << modelOrder) - 1;
	bm->context = 0;
	bm->pos = 7;
	bm->model = (PValPair) MemAlloc(sizeof(ValPair) * (bm->mask + 1));
	if(IsInvalidPtr(bm->model)) { 
		MemFree(bm);
		return NULL;
	};
	for(init = 0; init <= bm->mask; init++) {
		bm->model[init].v0 = 1;
		bm->model[init].vt = 2;
	};
	return bm;
};
__forceinline UINT HBMP1(PHBitModel bm) {
	bm->tmp = bm->model[(bm->context >> bm->pos) & bm->mask];
	return ((LONG) bm->tmp.v0 * (LONG) 0xFFFFFFFF) / ((LONG) bm->tmp.vt);
};
__forceinline void HBMUpdate(PHBitModel bm, BOOL bit) {
	bm->model[(bm->context >> bm->pos) & bm->mask].vt++;
	if(bit == FALSE) { 
		bm->model[(bm->context >> bm->pos) & bm->mask].v0++;
	} else {
		bm->context = bm->context ^ ((LONG) 1 << bm->pos);
	};
	if(bm->pos == 0) {
		bm->pos = 7;
		//bm->context = ((bm->context * (LONG) 3) << 6) & hmaxmask;
		bm->context = ((bm->context << 6) + (bm->context << 7)) & hmaxmask;
	} else {
		bm->pos--;
	};
};
void DestroyHBM(PHBitModel bm) {
	MemFree(bm->model);
	MemFree(bm);
};