const BYTE keyval = 0xF0;
typedef struct StreamCoder {
	PBUFFERED_FILE base;
	int val;
	int last;
	BOOL done;
	int count;
	BYTE buffer[258];
	int fill;
	int pos;
} StreamCoder, *PStreamCoder;
PStreamCoder InitStreamCoder(PBUFFERED_FILE basefile) {
	PStreamCoder sc = (PStreamCoder) MemAlloc(sizeof(StreamCoder));
	sc->base = basefile;
	sc->val = 0;
	sc->last = -1;
	sc->done = FALSE;
	sc->count = 0;
	sc->fill = 0;
	sc->pos = 0;
	return sc;
};
__forceinline void SCEncode(PStreamCoder sc) {
	sc->val = ReadBufferedByte(sc->base);
	if(sc->val == -1) {
		if(sc->count > 0) {
			sc->buffer[0] = keyval;
			sc->buffer[1] = (BYTE) sc->count;
			sc->buffer[2] = keyval;
			sc->buffer[3] = keyval;
			sc->buffer[4] = 0;
			sc->fill = 5;
			sc->count = 0;
			sc->last = -1;
			sc->done = TRUE;
		} else {
			sc->buffer[0] = keyval;
			sc->buffer[1] = keyval;
			sc->buffer[2] = 0;
			sc->fill = 3;
			sc->count = 0;
			sc->last = -1;
			sc->done = TRUE;
		};
	} else {
		if(sc->val == keyval) {
			if(sc->last == keyval) {
				sc->count++;
				if(sc->count == 0xFF) {
					sc->buffer[0] = keyval;
					sc->buffer[1] = (BYTE) sc->count;
					sc->fill = 2;
					sc->count = 0;
					sc->last = -1;
				};
			} else {
				sc->buffer[0] = keyval;
				sc->fill = 1;
				sc->count = 1;
				sc->last = (int) keyval;
			};
		} else {
			if(sc->count > 1) {
				sc->buffer[0] = keyval;
				sc->buffer[1] = (BYTE) sc->count;
				sc->buffer[2] = sc->val;
				sc->fill = 3;
				sc->count = 0;
				sc->last = sc->val;
			} else {
				sc->buffer[0] = (BYTE) sc->val;
				sc->fill = 1;
				sc->count = 0;
				sc->last = sc->val;
			};
		};
	};
};
__forceinline void SCDecode(PStreamCoder sc, BYTE val) {
	sc->val = val;
	if(sc->last == keyval) {
		if(sc->count == -1) {
			if(sc->val == 0) {
				sc->fill = 0;
				sc->done = TRUE;
			} else {
				sc->fill = 0;
				while(sc->val > 0) {
					sc->buffer[sc->fill] = keyval;
					sc->fill++;
					sc->val--;
				};
			};
			sc->last = -1;
			sc->count = 0;
		} else {
			if(sc->val == keyval) {
				sc->count = -1;
				sc->last = keyval;
			} else {
				sc->buffer[0] = keyval;
				sc->buffer[1] = (BYTE) sc->val;
				sc->fill = 2;
				sc->count = 0;
				sc->last = sc->val;
			};
		};
	} else {
		if(sc->val == keyval) {
			sc->last = keyval;
			sc->count = 0;
		} else {
			sc->buffer[0] = (BYTE) sc->val;
			sc->fill = 1;
			sc->last = sc->val;
			sc->count = 0;
		};
	};
};
__forceinline int SCReadByte(PStreamCoder sc) {
	if((sc->done == TRUE) && (sc->fill == 0)) { return -1; };
	while(sc->fill == 0) {
		sc->pos = 0;
		SCEncode(sc);
	};
	sc->val = sc->buffer[sc->pos];
	sc->fill--;
	sc->pos++;
	return (int) sc->val;
};
__forceinline void SCWriteByte(PStreamCoder sc, BYTE val) {
	SCDecode(sc, val);
	sc->pos = 0;
	while(sc->fill > 0) {
		WriteBufferedByte(sc->base, sc->buffer[sc->pos]);
		sc->fill--;
		sc->pos++;
	};
};
void DestroyStreamCoder(PStreamCoder sc) {
	MemFree(sc);
};