LONG const tmaxmask = 0x1FFFFFFFFFFFFFFF;
typedef struct MiniTextModel {
	ValPair c[2];
	BYTE last;
} MTModel, *PMTModel;
typedef struct TextModel {
	int order;
	PMTModel model;
	LONG context;
	LONG realctx;
	UINT mask;
	UINT pos;
	PSSEModel sse;
	MTModel temp;
	ValPair temp2;
} TModel, *PTModel;
PTModel InitTM(int modelOrder) {
	LONG init;
	PTModel bm = (PTModel) MemAlloc(sizeof(TModel));
	bm->order = modelOrder;
	bm->mask = (1 << modelOrder) - 1;
	bm->context = 0;
	bm->pos = 0;
	bm->model = (PMTModel) MemAlloc(sizeof(MTModel) * (bm->mask + 1));
	bm->sse = InitSSE(14);
	if(IsInvalidPtr(bm->model) || IsInvalidPtr(bm->sse)) {
		MemFree(bm);
		return NULL;
	};
	for(init = 0; init <= bm->mask; init++) {
		bm->model[init].c[0].v0 = 1;
		bm->model[init].c[0].vt = 2;
		bm->model[init].c[1].v0 = 1;
		bm->model[init].c[1].vt = 2;
		bm->model[init].last = (BYTE) FALSE;
	};
	return bm;
};
__forceinline UINT TMP1(PTModel bm) {
	bm->temp = bm->model[bm->realctx];
	bm->temp2 = bm->temp.c[bm->temp.last];
	return SSEPredict(bm->sse, ((LONG) bm->temp2.v0 * (LONG) 0xFFFFFFFF) / ((LONG) bm->temp2.vt));
};
__forceinline void TMUpdate(PTModel bm, BOOL bit) {
	bm->model[bm->realctx].c[bm->model[bm->realctx].last].vt++;
	if(bit == FALSE) {
		bm->model[bm->realctx].c[bm->model[bm->realctx].last].v0++;
		bm->model[bm->realctx].last = (BYTE) bit;
	} else {
		bm->model[bm->realctx].last = (BYTE) bit;
		bm->context = bm->context ^ ((LONG) 1 << bm->pos);
	};
	SSEUpdate(bm->sse, bit);
	if(bm->pos == 0) {
		bm->pos = 7;
		bm->context = ((bm->context << 6) + (bm->context << 7)) & tmaxmask;
	} else {
		bm->pos--;
	};
	//bm->realctx = (((bm->context >> bm->pos) << 3) | (LONG) bm->pos) & bm->mask;
	bm->realctx = (bm->context >> bm->pos) & bm->mask;
};
void DestroyTM(PTModel bm) {
	DestroySSE(bm->sse);
	MemFree(bm->model);
	MemFree(bm);
};